// abSDKDlg.cpp : implementation file
//


#include <time.h>
#include "stdafx.h"
#include "abSDK.h"
#include "abSDKDlg.h"
#include "DeviceSetupDlg.h" 

#include "Shellapi.h" 

#include "abDLLusb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern unsigned int iModel;
extern unsigned int uiOffset;
extern unsigned int uiDelay;
extern unsigned int uiSerial;
extern unsigned int uiFwVer;
extern long lTTest;
extern long lTRemained;
extern int btnClick;	//0:Cancel, 1:OK
extern unsigned int uiSeed;
extern int FMax[5]; 
extern int iStop;		//0:No, 1:Yes
extern int iDevice;
extern int inOvn;		//0:No, 1:Yes


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAbSDKDlg dialog

CAbSDKDlg::CAbSDKDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAbSDKDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAbSDKDlg)
	m_iEchoB = 27;
	m_uiSerial = 23456;
	m_uiPosition = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAbSDKDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAbSDKDlg)
	DDX_Control(pDX, ID_BTN_STOPOVN, m_ctrStop);
	DDX_Control(pDX, IDC_LIST_RESULT, m_lbResult);
	DDX_Control(pDX, ID_BTN_ECHO, m_ctrEcho);
	DDX_Control(pDX, ID_BTN_CLOSE, m_ctrClose);
	DDX_Text(pDX, IDC_ECHO_BYTE, m_iEchoB);
	DDV_MinMaxInt(pDX, m_iEchoB, 0, 255);
	DDX_Text(pDX, IDC_EPOSITION, m_uiPosition);
	DDV_MinMaxUInt(pDX, m_uiPosition, 0, 20);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAbSDKDlg, CDialog)
	//{{AFX_MSG_MAP(CAbSDKDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_BTN_CLOSE, OnBtnClose)
	ON_BN_CLICKED(ID_BTN_ECHO, OnBtnEcho)
	ON_BN_CLICKED(ID_BTN_CLEAR, OnBtnClear)
	ON_BN_CLICKED(ID_BTN_RESET, OnBtnReset)
	ON_BN_CLICKED(ID_BTN_QUERY, OnBtnQuery)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_POSITION, OnDeltaposSpinPosition)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_ZERO, OnDeltaposSpinZero)
	ON_COMMAND(IDM_CMD_EXIT, OnCmdExit)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(IDM_EE_SAVE, OnEeSave)
	ON_COMMAND(IDM_CMD_TEST, OnCmdTest)
	ON_BN_CLICKED(ID_BTN_STOPOVN, OnBtnStopovn)
	ON_BN_CLICKED(ID_BTN_SET, OnBtnSet)
	ON_EN_CHANGE(IDC_EPOSITION, OnChangeEposition)
	ON_WM_CLOSE()
	ON_COMMAND(IDM_CMD_SETUP, OnCmdSetup)
	ON_COMMAND(ID_HELP_README, OnHelpReadme)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAbSDKDlg message handlers

BOOL CAbSDKDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	inOvn=0;		//0:No, 1:Yes
	//OnBtnDevice();

    Queries();
	UpdateInfo();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAbSDKDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAbSDKDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAbSDKDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAbSDKDlg::OnBtnEcho() 
{
	// TODO: Add your control notification handler code here
	short sRtn, sByte;
	short *sEcho;
	CString strTmp;
	sEcho = new short[1];
	//TRUE: update variables
	UpdateData(TRUE);
	sByte = (short)m_iEchoB;

	  // AB300 Echoed Command
	  sRtn=abEcho(sByte, sEcho);
	  //0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	  if(sRtn !=0)
	    strTmp.Format(_T("An Error Has Occurred"));
	  else
	    strTmp.Format(_T("Echo Byte is : %u"), *sEcho);
	
	m_lbResult.AddString(strTmp);
	delete[] sEcho;
}

void CAbSDKDlg::OnDeltaposSpinPosition(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here

	//iDelta: -1=Up, 1=Dn. 
	short sRtn, sError;		//sError-0:OK, 4:NOK;

	time_t start, finish, Time1Cmd;	//time_t: long





	CString strTmp;
	sError=0;			//sError-0:OK, 4:NOK; 
	switch (pNMUpDown->iDelta)
	{
	  case 1:		//1=Dn
		if (iPos>1)
		{
		  iPos -=1;
		}
		else
		{
			sError=4;			//sError-0:OK, 4:NOK; 
			strTmp.Format(_T("The Range is : (1 - %u)"),FMax[iModel-301]);
		}
		break;
	  case -1:		//0=Up
		if (iPos < FMax[iModel-301])
		{
			iPos +=1;
		}
		else
		{
			sError=4;			//sError-0:OK, 4:NOK; 
			strTmp.Format(_T("The Range is : (1 - %u)"),FMax[iModel-301]);
		}
		break;
	  default:
		strTmp.Format(_T("An Error Has Occurred."));
		sError=4;			//sError-0:OK, 4:NOK; 
		break;
	}
	if (sError==0)
	{
		time( &start );
		
		sRtn=abGoto(iPos);
		
		time( &finish );
		Time1Cmd= (long)difftime( finish, start );
		
		
		
		m_uiPosition = iPos;
	  //TRUE: update variables
	  UpdateData(FALSE);
	}
	else
	  m_lbResult.AddString(strTmp);

	*pResult = 0;
}

void CAbSDKDlg::OnChangeEposition() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	CString strTmp;
	UINT uiPosTmp;
	//TRUE: update variables
	UpdateData(TRUE);
	uiPosTmp=m_uiPosition;

	if ((uiPosTmp<1)||(uiPosTmp > (UINT) FMax[iModel-301]))
	{
		m_uiPosition= FMax[iModel-301];
		//TRUE: update variables
		UpdateData(FALSE);
	    strTmp.Format(_T("The Range is : (1 - %u)"),FMax[iModel-301]);
	    m_lbResult.AddString(strTmp);
	}
	
}

void CAbSDKDlg::OnBtnSet() 
{
	// TODO: Add your control notification handler code here
	
	CString strTmp;
	short sRtn;
	int iFNum;
	//TRUE: update variables
	UpdateData(TRUE);
	iFNum=m_uiPosition;

	sRtn=abGoto(iFNum);
	if(sRtn==0)
	{
	  iPos=iFNum;
	  strTmp.Format(_T("Current Filter  : %u"),iPos);
	  m_lbResult.AddString(strTmp);
	}
}

short CAbSDKDlg::UpdateInfo()
{
	short sRtn;
	sRtn=0;		//0:OK
	m_uiPosition = iPos;
	
	m_uiSerial=uiSerial;
	//TRUE: update variables
	UpdateData(FALSE);
	return sRtn;
}

short CAbSDKDlg::Queries()
{	//0: no error, 4: error occurred
	short sRtn, sRtn2;
	short *sData;
	sData = new short[8];

	sRtn2=0;		//0:OK
	//[0]:Pwr, [1]:Position, [2,3]:Model, [4,5]:Offset, [6,7]:Version
	// Query Command
	sRtn=abQuery(sData);
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	if(sRtn !=0)
	  sRtn2=sRtn;
	else
	{
	  iPower=sData[0];
	  iPos=sData[1];
	  iModel=sData[2]*256+sData[3];
	  uiOffset=sData[4]*256+sData[5];
	  uiFwVer=sData[6]*256+sData[7];
	  FwVer.Format(_T("FW Version: %u.%u"),sData[6],sData[7]);

	  //[0,1]:Model, [2,3]:Offset, [4,5]:Delay, [6,7]:Serial
	  // AB300 Echoed Command
	  sRtn=abRdEeprom(sData);
	  uiSerial=sData[6]*256+sData[7];
	  uiDelay=sData[4]*256+sData[5];

	  if(sRtn !=0)
	    sRtn2=sRtn;
	}
	delete[] sData;
	return sRtn2;
}

void CAbSDKDlg::OnBtnQuery() 
{
	// TODO: Add your control notification handler code here
	short sRtn;
	short *sData;
	CString strTmp;
	sData = new short[8];
	//[0]:Pwr, [1]:Pos, [2,3]:Model, [4,5]:Offset, [6,7]:Version
	// AB300 Echoed Command
	sRtn=abQuery(sData);
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));
	else
	{
	  iPower=sData[0];
	  iPos=sData[1];
	  if (iPower)
	    strTmp.Format(_T("DC Power  : On"));
	  else
		strTmp.Format(_T("DC Power  : Off"));
	  m_lbResult.AddString(strTmp);
	  uiFwVer=sData[6]*256+sData[7];
	  FwVer.Format(_T("FW Version: %u.%u "),sData[6],sData[7]);
	  m_lbResult.AddString(FwVer);
	  uiOffset=sData[4]*256+sData[5];
	  strTmp.Format(_T("Offset    : %u"),uiOffset);
	  m_lbResult.AddString(strTmp);
	  iModel=sData[2]*256+sData[3];
	  strTmp.Format(_T("Model     : %u\0x0d\0x0a"),iModel);
	}
	m_lbResult.AddString(strTmp);
	delete[] sData;
	m_uiPosition = iPos;			//Update new position 
	UpdateData(FALSE);				//display it
}

void CAbSDKDlg::OnBtnReset() 
{
	// TODO: Add your control notification handler code here
	short sRtn;
	CString strTmp;
	//TRUE: update variables
	UpdateData(TRUE);
    // AB300 Echoed Command
    sRtn=abReset();
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));
	else
	{
	  strTmp.Format(_T("Reset was completed"));
	  iPos=1;
	  m_uiPosition = iPos;
	  //TRUE: update variables
	  UpdateData(FALSE);
	}
	m_lbResult.AddString(strTmp);
}

void CAbSDKDlg::OnBtnStopovn() 
{
	// TODO: Add your control notification handler code here
	iStop=1;		//0:No, 1:Yes
	m_ctrStop.ShowWindow(FALSE);

	m_uiPosition= iPosNext;
	//TRUE: update variables
	UpdateData(FALSE);
	inOvn=0;		//0:No, 1:Yes
}

void CAbSDKDlg::OnBtnClear() 
{
	// TODO: Add your control notification handler code here
	int i;
	i=m_lbResult.GetCount();
	for(i; i>0; i--)
		m_lbResult.DeleteString(i-1);
}

void CAbSDKDlg::OnBtnClose() 
{
	// TODO: Add your control notification handler code here

	CString strTmp;
	if(inOvn==1)		//0:No, 1:Yes
	{
	  strTmp.Format(_T("STOP the Test First "));
	  AfxMessageBox(strTmp);
	  return;
	}

	CDialog::OnCancel();
}



void CAbSDKDlg::OnDeltaposSpinZero(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here

	short sRtn;
	CString strTmp;
	//iDelta: -1=Up, 1=Dn. 
	switch (pNMUpDown->iDelta)
	{
	  case 1:		//1=Dn
		  // Step Down Command
		  strTmp.Format(_T("'StepDn' "));
		  sRtn=abStepDn();
		  break;
	  case -1:		//0=Up
		  // Step Up Command
		  strTmp.Format(_T("'StepUp' "));
		  sRtn=abStepUp();
		  break;
	  default:

	 	  break;
	}
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));

	m_lbResult.AddString(strTmp);
	*pResult = 0;
}


void CAbSDKDlg::OnCmdTest() 
{
	// TODO: Add your command handler code here

	OnBtnClear(); 
	m_ctrStop.ShowWindow(TRUE);
	inOvn=1;		//0:No, 1:Yes
	AfxBeginThread(ThreadProc,reinterpret_cast<LPVOID>(this));
	//Goes through immediately    
}

short CAbSDKDlg::RndFunc()
{	//0:OK, 4:NOK
	CString strTmp;
	short sRtn; 
	int iRndPos;
	sRtn=0;
	
	iRndPos = (rand() % FMax[iModel-301]) + 1;		//1=offset
	iPosNext= iRndPos;

	sRtn=abGoto(iRndPos);
	Sleep(250);									//do nothing for 250mS
	if(sRtn==0)
	{
	  iPos=iRndPos;
	  strTmp.Format(_T("Current Filter  : %u"),iPos);
	  m_lbResult.AddString(strTmp);
	  strTmp.Format(_T("Minutes to Test : %u"),lTRemained);
	  m_lbResult.AddString(strTmp);	

	}
	return sRtn;
}

void CAbSDKDlg::DoTest()
{
	short sRtn;
	CString strTmp;
	time_t start, finish, Time1Cmd;	//time_t: long
	//int btnClick;	//0:Cancel, 1:OK
	m_dTestSetup.DoModal();
	
	iStop=0;		//0:No, 1:Yes
	
	time( &start );
	if (btnClick==1)
	{
	  srand(uiSeed);
	  do
	  {
		sRtn=RndFunc();

		time( &finish );
		Time1Cmd= (long)difftime( finish, start );
		lTRemained= lTTest - Time1Cmd/60;
		if (lTRemained<0)
			lTRemained=0;
		if(iStop)
			lTRemained=0;
	  }
	  while (lTRemained >0);
	  
	  iStop=1;		//0:No, 1:Yes
	  m_ctrStop.ShowWindow(FALSE);
	  inOvn=0;		//0:No, 1:Yes
	}
}

UINT CAbSDKDlg::ThreadProc(LPVOID lpParam)
{
	CAbSDKDlg *pThis=reinterpret_cast<CAbSDKDlg *>(lpParam);
	pThis->DoTest();

    return 1;
}

void CAbSDKDlg::OnCmdExit() 
{
	// TODO: Add your command handler code here

	CString strTmp;
	if(inOvn==1)		//0:No, 1:Yes
	{
	  strTmp.Format(_T("STOP the Test First "));
	  AfxMessageBox(strTmp);
	  return;
	}

	OnOK();	
}

void CAbSDKDlg::OnEeSave() 
{
	CFileDialog FileDlg(FALSE, _T(".txt"), NULL, 0, _T("Text File (.txt)|*.txt|")
		_T("All files (*.*)|*.*||"));

	if (FileDlg.DoModal() == IDOK)
	{
		const int numItems = m_lbResult.GetCount();			//get number of lines 
		CString itemText;
		CString FileName;
		CStdioFile file;

		//check for existing file and overwrite if user chooses to
		CFileStatus fileStatus;
		BOOL bReturnStatus = FALSE;

		FileName = FileDlg.GetPathName();						//get file name
		bReturnStatus = CFile::GetStatus(FileName, fileStatus);	//see if it exists
		
		if (bReturnStatus)				//if it exists -overwrite?
		{
			int iReturn = AfxMessageBox(_T("This file already exists!\n Do you want to overwrite it?"), MB_YESNO);
			if ( iReturn == IDNO) return;
		}


		//write info from listbox to file
		if(file.Open(FileDlg.GetFileName(), CStdioFile::modeCreate| CStdioFile::modeWrite))
		{
			for (int i=0; i< numItems; i++)
			{
				m_lbResult.GetText(i, itemText);
				file.WriteString(itemText);
				file.WriteString(_T("\n"));
			}
			file.Close();
		}
	}
}



void CAbSDKDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();	
}



void CAbSDKDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	//This is the x mark on the top right corner
	CString strTmp;
	if(inOvn==1)		//0:No, 1:Yes
	{
	  strTmp.Format(_T("STOP the Test First "));
	  AfxMessageBox(strTmp);
	  return;
	}
	
	CDialog::OnClose();
}



void CAbSDKDlg::OnCmdSetup() 
{
	//call device setup dialog box
	CDeviceSetupDlg aDlg;		//create a local dialog object

	//display dialog
	aDlg.DoModal();

	
}

void CAbSDKDlg::OnHelpReadme() 
{
	// TODO: Add your command handler code here

	char strPathName[_MAX_PATH];
		::GetModuleFileName(NULL, strPathName, _MAX_PATH);

		// The following code will allow you to get the path.
		CString newPath(strPathName);
		int fpos = newPath.ReverseFind('\\');

		if (fpos != -1)
			newPath = newPath.Left(fpos + 1);
		newPath += "AB300USB_Help.txt";

		//AfxMessageBox(newPath,MB_OK);
	ShellExecute(NULL,"open","notepad.exe",newPath,NULL,SW_SHOWNORMAL);
	
}
