// cTestSetup.cpp : implementation file
//

#include "stdafx.h"
#include "abSDK.h"
#include "cTestSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern unsigned int uiSeed;
extern long lTTest;
extern long lTRemained;
extern int btnClick;	//0:Cancel, 1:OK

/////////////////////////////////////////////////////////////////////////////
// cTestSetup dialog


cTestSetup::cTestSetup(CWnd* pParent /*=NULL*/)
	: CDialog(cTestSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(cTestSetup)
	m_uiSeed = 1;
	m_lMinutes = 30;
	//}}AFX_DATA_INIT
}


void cTestSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(cTestSetup)
	DDX_Text(pDX, IDC_ESEED, m_uiSeed);
	DDV_MinMaxUInt(pDX, m_uiSeed, 0, 65535);
	DDX_Text(pDX, IDC_EMINUTES, m_lMinutes);
	DDV_MinMaxLong(pDX, m_lMinutes, 1, 1440);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(cTestSetup, CDialog)
	//{{AFX_MSG_MAP(cTestSetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// cTestSetup message handlers

void cTestSetup::OnOK() 
{
	// TODO: Add extra validation here

	//TRUE: update variables
	UpdateData(TRUE);
	uiSeed=m_uiSeed;
	lTTest=m_lMinutes;
	lTRemained=lTTest;
	btnClick=1;		//0:Cancel, 1:OK
	CDialog::OnOK();
}

void cTestSetup::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	btnClick=0;		//0:Cancel, 1:OK
	CDialog::OnCancel();
}
