// SaveSetup.cpp : implementation file
//

#include "stdafx.h"
#include "abSDK.h"
#include "SaveSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern unsigned int iModel;
extern unsigned int uiOffset;
extern unsigned int uiDelay;
extern unsigned int uiSerial;
extern unsigned int uiFwVer;


/////////////////////////////////////////////////////////////////////////////
// SaveSetup dialog


SaveSetup::SaveSetup(CWnd* pParent /*=NULL*/)
	: CDialog(SaveSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(SaveSetup)
	m_sFileName = _T("");
	//}}AFX_DATA_INIT
}


void SaveSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SaveSetup)
	DDX_Text(pDX, IDC_EFILENAME, m_sFileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SaveSetup, CDialog)
	//{{AFX_MSG_MAP(SaveSetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SaveSetup message handlers

BOOL SaveSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
    CString strTmp;
	strTmp.Format(_T("%u"), uiSerial);
	m_sFileName= strTmp;
	//TRUE: update variables
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void SaveSetup::OnOK() 
{
	// TODO: Add extra validation here
	
	// Data saving
	CString strTmp, strName, strSerial;
    unsigned int *uiData;
	uiData = new unsigned int[8];

	uiData[0]= iModel;
	uiData[1]= uiOffset;
	uiData[2]= uiDelay;
	uiData[3]= uiSerial;
	uiData[4]= uiFwVer;


	//.........................................................
	int i;
	strName = m_sFileName + _T(".Eep");
	HFILE file = _lcreat(strName, 0);
	if(file)
	{
	  char strTemp[20];
	  for(i=0; i<5 ; i++)
	  {
	    sprintf(strTemp," %5u \r\n", uiData[i]);
		_lwrite(file, (LPSTR)strTemp, strlen(strTemp));
	  }
	  _lclose(file);
	}
	else
	{
	   strTmp.Format(_T("Error has occurred!!"));
	   AfxMessageBox(strTmp);
	}
//.........................................................

	delete[] uiData;
	CDialog::OnOK();
}


void SaveSetup::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

