// abSDKDlg.h : header file
//

#if !defined(AFX_ABSDKDLG_H__303F4D0C_38F2_4B5F_96A2_09C5FA916D3D__INCLUDED_)
#define AFX_ABSDKDLG_H__303F4D0C_38F2_4B5F_96A2_09C5FA916D3D__INCLUDED_

#include "SaveSetup.h"	// Added by ClassView
#include "cTestSetup.h"	// Added by ClassView
#include "TimeRemained.h"	// Added by ClassView
#include "DeviceDlg.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CAbSDKDlg dialog

class CAbSDKDlg : public CDialog
{
// Construction
public:
	CDeviceDlg m_dDevice;
	static UINT ThreadProc( LPVOID lpParam );
	void DoTest();

	short RndFunc();
	CTimeRemained m_dTRemained;
	cTestSetup m_dTestSetup;
	SaveSetup m_dSaveSetupDlg;
	CAbSDKDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAbSDKDlg)
	enum { IDD = IDD_ABSDK_DIALOG };
	CComboBox	m_cboDevice;
	CButton	m_ctrStop;
	CButton	m_ctrRead;
	CListBox	m_lbResult;
	CComboBox	m_cboABType;
	CButton	m_ctrEcho;
	CButton	m_ctrClose;
	int		m_iEchoB;
	UINT	m_uiDelay;
	UINT	m_uiOffset;
	UINT	m_uiSerial;
	UINT	m_uiPosition;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAbSDKDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	short UpdateInfo();
	short Queries();
	HICON m_hIcon;
	union
	{
		unsigned int UInt;
		unsigned char UChar[2];
	} TwoUChar;
	int iPower;			// 0:NoDC, 1:YesDC
	int iPos;
	int iPosNext;
	short sAbType;
	CString FwVer;		// Firmware Version: XXX.XXX

	// Generated message map functions
	//{{AFX_MSG(CAbSDKDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnClose();
	afx_msg void OnBtnEcho();
	afx_msg void OnBtnClear();
	afx_msg void OnBtnReset();
	afx_msg void OnBtnQuery();
	afx_msg void OnDeltaposSpinPosition(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBtnRead();
	afx_msg void OnBtnWrite();
	afx_msg void OnDeltaposSpinZero(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBtnZero();
	afx_msg void OnCmdExit();
	afx_msg void OnHelpAbout();
	afx_msg void OnEeSave();
	afx_msg void OnCmdTest();
	afx_msg void OnBtnStopovn();
	afx_msg void OnBtnSet();
	afx_msg void OnChangeEposition();
	afx_msg void OnBtnDevice();
	afx_msg void OnClose();
	afx_msg void OnSelchangeListResult();
	afx_msg void OnSetfocusListResult();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ABSDKDLG_H__303F4D0C_38F2_4B5F_96A2_09C5FA916D3D__INCLUDED_)
